import Ember from 'ember';

const {
    Component,
    inject: {service},
    computed
} = Ember;

export default Component.extend({
    tagName: 'nav',
    classNames: ['gh-nav'],
    classNameBindings: ['open'],

    open: false,

    navMenuIcon: computed('ghostPaths.subdir', function () {
        let url = `${this.get('ghostPaths.subdir')}/ghost/img/ghosticon.jpg`;

        return Ember.String.htmlSafe(`background-image: url(${url})`);
    }),

    config: service(),
    session: service(),
    ghostPaths: service(),

    mouseEnter() {
        this.sendAction('onMouseEnter');
    },

    actions: {
        toggleAutoNav() {
            this.sendAction('toggleMaximise');
        },

        showMarkdownHelp() {
            this.sendAction('showMarkdownHelp');
        },

        closeMobileMenu() {
            this.sendAction('closeMobileMenu');
        },

        openAutoNav() {
            this.sendAction('openAutoNav');
        }
    }
});
